#! /bin/bash

# Public Domain

rm -f lmsdos.bin
rm -f lmsdos.lz
rm -f lmsdos.pak
rm -f lmsdos.com
rm -f lmsdos.sys
rm -f lmspack.com
rm -f lmspack.sys

if [ "$1" == "onlypl" ]
then
  shift
else
  [[ -z "$DOSEMU" ]] && DOSEMU=dosemu
  "$DOSEMU" -dumb -td -kt < /dev/null -K "$PWD" -E "mak.bat"
fi

notracelist=0
if [[ "$1" == "notracelist" ]]
then
  shift
  notracelist=1
fi

nasm version.asm -I ../lmacros/ -o version.com

nasm ../ldosboot/drkernpl.asm -I ../lmacros/ \
  -I src/ -o lmsdos.bin \
  -D_PAYLOAD_BIO_FILE="'msbio.bin'" -D_PAYLOAD_DOS_FILE="'msdos.sys'" \
  "$@"
lzip -9vvfkc lmsdos.bin > lmsdos.lz
nasm ../inicomp/inicomp.asm -I ../inicomp/ -I ../lmacros/ \
  -D_PAYLOAD_FILE='"lmsdos.lz"' -o lmsdos.pak -D_LZD \
  -D_COUNTER "$@"
nasm ../ldosboot/iniload.asm -I ../ldosboot/ -I ../lmacros/ -I ../scanptab/ \
  -D_PAYLOAD_FILE='"lmsdos.pak"' -D_INILOAD_SIGNATURE='"MS"' -o lmspack.com \
  -D_SECOND_PAYLOAD_EXE -D_SECOND_PAYLOAD_FILE='"version.com"' \
  -D_SECOND_PAYLOAD_EXE_IP=256 \
  "$@"
nasm ../ldosboot/iniload.asm -I ../ldosboot/ -I ../lmacros/ -I ../scanptab/ \
  -D_PAYLOAD_FILE='"lmsdos.bin"' -D_INILOAD_SIGNATURE='"MS"' -o lmsdos.com \
  -D_SECOND_PAYLOAD_EXE -D_SECOND_PAYLOAD_FILE='"version.com"' \
  -D_SECOND_PAYLOAD_EXE_IP=256 \
  "$@"
nasm ../ldosboot/drload.asm -I ../lmacros/ \
  -D_PAYLOAD_FILE='"lmsdos.pak"' -o lmspack.sys "$@"
nasm ../ldosboot/drload.asm -I ../lmacros/ \
  -D_PAYLOAD_FILE='"lmsdos.bin"' -o lmsdos.sys "$@"

if ! (( notracelist ))
then
  echo === Creating BIO trace listing
  (cd src/BIOS/;
  cat MSBIO.LNK |
  grep -Eio '\S+\.obj' |
  sed -re 's/\\/\//g;s/\.obj/\.lst/g;s/\/inc\//\/INC\//g' |
  xargs convmasm.pl msbio.map > msbio.tls)
  echo === Creating DOS trace listing
  (cd src/DOS/;
  cat MSDOS.LNK |
  grep -Eio '\S+\.obj' |
  sed -re 's/\\/\//g;s/\.obj/\.lst/g;s/\/inc\//\/INC\//g' |
  xargs convmasm.pl msdos.map > msdos.tls)
  echo === Creating COMMAND trace listing
  (cd src/CMD/COMMAND/;
  cat COMMAND.LNK |
  grep -Eio '\S+\.obj' |
  sed -re 's/\\/\//g;s/\.obj/\.lst/g;s/\/inc\//\/INC\//g' |
  xargs convmasm.pl command.map > command.tls)
fi
